> For the complete documentation index, see [llms.txt](https://docs.nuvolos.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nuvolos.com/reference/applications/long-running-applications.md).

# Long-running applications

Nuvolos aims to provide the maximal resources for applications that require it, whilst freeing up resources from unused applications to optimize organization resource usage. As described below, we provide convenient default policies that:

* Allow long running computations to finish without user interaction.
* Stop inactive applications, to free up resources for other organization members / minimize credit usage.

We achieve the above through our automatic inactivity stopper as described below.

{% hint style="info" %}
For certain applications such as RStudio, long-running computations are best done using specific features off the app (e.g. RStudio jobs). Please take a look at the [application-specific guides](/how-to-guides/application-specific-guides.md) as well.
{% endhint %}

## Automatic stopping due to inactivity

Nuvolos automatically stops inactive Applications to allocate resources efficiently. Research and education Spaces are handled differently. The policy is enforced regardless of the Application type or size.

### Research Spaces

In research Spaces, an Application is considered active if either of the following is true:

* It is actively opened on Nuvolos and in focus in the browser, or
* It is actively computing (using more than half of a single virtual CPU).

Default inactivity limits in research Spaces:

* **6 hours** for Included-size Applications.
* **1 hour** for credit-based Applications.

Space administrators can set the inactivity limit between **1 and 24 hours** for Included-size Applications. This setting has no effect on credit-based Applications.

Researchers can launch long-running computations and the Application will keep running while it is actively computing. If the computation finishes (either by completion or by error) and the Application is not opened on Nuvolos, it is auto-stopped. We therefore recommend explicitly capturing and saving output logs to ensure that any warnings or errors are preserved.

### Education spaces

In education Spaces, the default inactivity limit for any Application type is **1 hour.** To keep an Application active, the Application must be in focus in your browser for more than one (uninterrupted) minute every hour.

### Configure the inactivity limit

Each Application can have its inactivity limit set on the Configuration screen, within the limits above. For more details see [Application configuration](/reference/applications/configuring-applications.md).

## Long-running Applications

Nuvolos supports long-running Applications while automatically stopping inactive ones, balancing maximal resource availability for active workloads against efficient release of unused resources.

#### Application-specific long-running guidance

* RStudio - for long-running computations, use RStudio jobs (the application's own background-job feature) rather than running directly in the foreground.
* JupyterLab - for long-running notebooks, use Papermill rather than running cells directly. This avoids the long-standing cell-output streaming issue: when you close your browser window during a long-running notebook, no new messages stream to the cell output when you return.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.nuvolos.com/reference/applications/long-running-applications.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
